<?php

namespace backend\controllers;

use Yii;
use common\models\DoorLog;
use backend\models\DoorLogSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * DoorLogController implements the CRUD actions for DoorLog model.
 * 
 * TODO: FIX ACCESS
 */
class DoorLogController extends Controller
{
	public function behaviors()
	{
		return [
				'access' => [
						'class' => \yii\filters\AccessControl::className(),
						'rules' => [
								// allow authenticated users
								[
										'actions' => [  ],
										'allow' => true,
										'roles' => ['admin','employee','reception'],
								],
								// everything else is denied
						],
				],
		];
	}

    /**
     * Lists all DoorLog models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new DoorLogSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single DoorLog model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new DoorLog model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
    public function actionCreate()
    {
        $model = new DoorLog();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_door_log]);
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }
     */

    /**
     * Updates an existing DoorLog model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_door_log]);
        } else {
            return $this->render('update', [
                'model' => $model,
            ]);
        }
    }
     */

    /**
     * Deletes an existing DoorLog model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }
     */

    /**
     * Finds the DoorLog model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return DoorLog the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = DoorLog::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
}
